<template>
  <div class="editableTable">
    <CDataTable
      :items="tableData"
      :fields="fields"
      :items-per-page="100"
      :loading="isLoading || isLoadingProp"
    >
      <template #edit="{item}">
        <td class="py-2 editingCell">
          <CButton
            color="primary"
            variant="outline"
            square
            size="sm"
            :disabled="isShowEdit"
            @click="openEdit(item)"
          >
            Редактировать
          </CButton>
        </td>
      </template>
      <template #details="{item}">
        <CCollapse
          v-if="localEditableItemId === item.id"
          :show="isShowEdit"
        >
          <slot/>
        </CCollapse>
      </template>
    </CDataTable>
  </div>
</template>

<script>
  export default {
    name: "EditableTable",
    props: {
      tableHead: {
        // Массив объектов для заголовка таблицы
        type: Array,
        required: true,
      },
      tableData: {
        // Массив объектов с информацией о полях таблицы
        type: Array,
        required: true,
      },
      editableItemId: {
        // Id редактируемой строки таблицы
        type: Number,
        default: 0,
      },
      // Состояние прелоадера таблицы
      isLoadingProp: Boolean,
    },
    data() {
      return {
        fields: [],
        items: [],
        isLoading: false,
        isShowEdit: false,
        localEditableItemId: 0,
      }
    },
    watch: {
      editableItemId(id) {
        // Плавное открытие/закрытие редактируемой ячейки. После закрытия происходит удаление из DOM
        if (id) {
          this.localEditableItemId = id;
          this.$nextTick(() => this.isShowEdit = true);
        } else {
          this.isShowEdit = false;
          this.$nextTick(() => setTimeout(() => this.localEditableItemId = 0, 400));
        }
      },
    },
    mounted() {
      this.fields = [...this.tableHead, {key: 'edit', label: ''}];
    },
    methods: {
      openEdit(item) {
        this.$emit('openEdit', item);
      },
    },
  }
</script>
